/*
 * Copyright (C) 2011-2012 OGIS-RI Co.,Ltd. All rights reserved.
 *
 * The software in this package is published under the terms of the CPAL v1.0
 * license, a copy of which has been included with this distribution in the
 * LICENSE.txt file.
 */
package jp.co.ogis_ri.citk.policytool.common.api.impl.model;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * <p>
 * Java class for anonymous complex type.
 * 
 * <p>
 * The following schema fragment specifies the expected content contained within
 * this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{}Rule" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{}Subjects" minOccurs="0"/>
 *         &lt;element ref="{}Conditions" minOccurs="0"/>
 *         &lt;element ref="{}Referrals" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="name" use="required" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="description" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="createdby" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="lastmodifiedby" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="creationdate" type="{http://www.w3.org/2001/XMLSchema}long" />
 *       &lt;attribute name="lastmodifieddate" type="{http://www.w3.org/2001/XMLSchema}long" />
 *       &lt;attribute name="referralPolicy" type="{http://www.w3.org/2001/XMLSchema}boolean" />
 *       &lt;attribute name="active" type="{http://www.w3.org/2001/XMLSchema}boolean" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {"rule", "subjects", "conditions", "referrals"})
@XmlRootElement(name = "Policy")
public class OpenAMPolicy {

    @XmlElement(name = "Rule")
    protected List<OpenAMRule> rule;
    @XmlElement(name = "Subjects")
    protected OpenAMSubjects subjects;
    @XmlElement(name = "Conditions")
    protected OpenAMConditions conditions;
    @XmlElement(name = "Referrals")
    protected OpenAMReferrals referrals;
    @XmlAttribute(required = true)
    protected String name;
    @XmlAttribute
    protected String description;
    @XmlAttribute
    protected String createdby;
    @XmlAttribute
    protected String lastmodifiedby;
    @XmlAttribute
    protected Long creationdate;
    @XmlAttribute
    protected Long lastmodifieddate;
    @XmlAttribute
    protected Boolean referralPolicy;
    @XmlAttribute
    protected Boolean active;

    /**
     * Gets the value of the rule property.
     * 
     * <p>
     * This accessor method returns a reference to the live list, not a
     * snapshot. Therefore any modification you make to the returned list will
     * be present inside the JAXB object. This is why there is not a
     * <CODE>set</CODE> method for the rule property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * 
     * <pre>
     * getRule().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link OpenAMRule }
     * 
     * 
     */
    public List<OpenAMRule> getRule() {
        if (rule == null) {
            rule = new ArrayList<OpenAMRule>();
        }
        return this.rule;
    }

    /**
     * Gets the value of the subjects property.
     * 
     * @return possible object is {@link OpenAMSubjects }
     * 
     */
    public OpenAMSubjects getSubjects() {
        return subjects;
    }

    /**
     * Sets the value of the subjects property.
     * 
     * @param value allowed object is {@link OpenAMSubjects }
     * 
     */
    public void setSubjects(OpenAMSubjects value) {
        this.subjects = value;
    }

    /**
     * Gets the value of the conditions property.
     * 
     * @return possible object is {@link OpenAMConditions }
     * 
     */
    public OpenAMConditions getConditions() {
        return conditions;
    }

    /**
     * Sets the value of the conditions property.
     * 
     * @param value allowed object is {@link OpenAMConditions }
     * 
     */
    public void setConditions(OpenAMConditions value) {
        this.conditions = value;
    }

    /**
     * Gets the value of the referrals property.
     * 
     * @return possible object is {@link OpenAMReferrals }
     * 
     */
    public OpenAMReferrals getReferrals() {
        return referrals;
    }

    /**
     * Sets the value of the referrals property.
     * 
     * @param value allowed object is {@link OpenAMReferrals }
     * 
     */
    public void setReferrals(OpenAMReferrals value) {
        this.referrals = value;
    }

    /**
     * Gets the value of the name property.
     * 
     * @return possible object is {@link String }
     * 
     */
    public String getName() {
        return name;
    }

    /**
     * Sets the value of the name property.
     * 
     * @param value allowed object is {@link String }
     * 
     */
    public void setName(String value) {
        this.name = value;
    }

    /**
     * Gets the value of the description property.
     * 
     * @return possible object is {@link String }
     * 
     */
    public String getDescription() {
        return description;
    }

    /**
     * Sets the value of the description property.
     * 
     * @param value allowed object is {@link String }
     * 
     */
    public void setDescription(String value) {
        this.description = value;
    }

    /**
     * Gets the value of the createdby property.
     * 
     * @return possible object is {@link String }
     * 
     */
    public String getCreatedby() {
        return createdby;
    }

    /**
     * Sets the value of the createdby property.
     * 
     * @param value allowed object is {@link String }
     * 
     */
    public void setCreatedby(String value) {
        this.createdby = value;
    }

    /**
     * Gets the value of the lastmodifiedby property.
     * 
     * @return possible object is {@link String }
     * 
     */
    public String getLastmodifiedby() {
        return lastmodifiedby;
    }

    /**
     * Sets the value of the lastmodifiedby property.
     * 
     * @param value allowed object is {@link String }
     * 
     */
    public void setLastmodifiedby(String value) {
        this.lastmodifiedby = value;
    }

    /**
     * Gets the value of the creationdate property.
     * 
     * @return possible object is {@link Long }
     * 
     */
    public Long getCreationdate() {
        return creationdate;
    }

    /**
     * Sets the value of the creationdate property.
     * 
     * @param value allowed object is {@link Long }
     * 
     */
    public void setCreationdate(Long value) {
        this.creationdate = value;
    }

    /**
     * Gets the value of the lastmodifieddate property.
     * 
     * @return possible object is {@link Long }
     * 
     */
    public Long getLastmodifieddate() {
        return lastmodifieddate;
    }

    /**
     * Sets the value of the lastmodifieddate property.
     * 
     * @param value allowed object is {@link Long }
     * 
     */
    public void setLastmodifieddate(Long value) {
        this.lastmodifieddate = value;
    }

    /**
     * Gets the value of the referralPolicy property.
     * 
     * @return possible object is {@link Boolean }
     * 
     */
    public Boolean isReferralPolicy() {
        return referralPolicy;
    }

    /**
     * Sets the value of the referralPolicy property.
     * 
     * @param value allowed object is {@link Boolean }
     * 
     */
    public void setReferralPolicy(Boolean value) {
        this.referralPolicy = value;
    }

    /**
     * Gets the value of the active property.
     * 
     * @return possible object is {@link Boolean }
     * 
     */
    public Boolean isActive() {
        return active;
    }

    /**
     * Sets the value of the active property.
     * 
     * @param value allowed object is {@link Boolean }
     * 
     */
    public void setActive(Boolean value) {
        this.active = value;
    }

}
